/* ----------------------------------------------------------------------------
 *  $RCSfile: rip.c,v $
 * 
 * $Revision: 1.2 $
 *   $Author: larse $
 *     $Date: 2000/06/07 16:43:18 $
 *    $State: Exp $
 * ----------------------------------------------------------------------------
 * Copyright 1999-2000, Lars Eggert <larse@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the "Artistic License" which comes with this
 * Kit.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * Artistic License for more details.
 * ----------------------------------------------------------------------------
 *
 * $Log: rip.c,v $
 * Revision 1.2  2000/06/07 16:43:18  larse
 * Moved software over to sourceforge.net under the Artistic License. No
 * functional changes to latest release.
 *
 * Revision 1.1  1999/08/10 22:15:56  larse
 * Preliminary RIP support (still lacking most options.)
 *
 * ----------------------------------------------------------------------------
 */


/* Define a marker for ident(1). */
static const char rcsid[] = 
  "$Id: rip.c,v 1.2 2000/06/07 16:43:18 larse Exp $";


#include <stdio.h>

#include "ipdump.h"
#include "indent.h"
#include "scan.h"


/* local header id */
static const char hdr[] = "RIP";

struct rip_entry
  {
  u_short addr_fam_id;
  u_short route_tag; /* v1: unused */
  u_long addr;
  u_long subnet_mask; /* v1: unused */
  u_long next_hop; /* v1: unused */
  u_long metric;
  };


struct rip_hdr
  {
  u_char cmd;
  u_char version;
  u_short unused;
  };


void print_ripv1(void)
  {
  while(left() >= sizeof(struct rip_entry))
    {
    const struct rip_entry *ripe = 
      (struct rip_entry *)next(sizeof(struct rip_hdr));
    if(ripe == 0) return;
    iprintf(hdr, "address family identifier: %lu", ntohl(ripe->addr_fam_id));
    if(ntohl(ripe->addr_fam_id) == 2) printf(" [AF_INET]\n");
    else
      {
      unsupported = 1;
      printf(" [*unsupported*]\n");
      break;
      }
    print_address(hdr, "address", &ripe->addr);
    printf("\n");
    iprintf(hdr, "metric: %lu", ntohl(ripe->addr_fam_id));
    if(ripe->metric == 16) printf(" [infinity]\n");
    else printf("\n");
    }
  }


void print_ripv2(void)
  {
  }


/* print rip */
void print_rip(void)
  {
  const struct rip_hdr *rip = (struct rip_hdr *)next(sizeof(struct rip_hdr));
  if(rip == 0) return;
  iprintf(hdr, "command: %hu", rip->cmd);
  switch(rip->cmd)
    {
    case 1: printf(" [request]\n"); break;
    case 2: printf(" [response]\n"); break;
    default:
      unsupported = 1;
      printf(" [*unsupported*]\n"); 
      break;
    }
  iprintf(hdr, "version: %hu\n", rip->version);
  switch(rip->version)
    {
    case 1: print_ripv1(); break;
    case 2: print_ripv2(); break;
    default:
      unsupported = 1;
      printf(" [*unsupported*]\n"); 
      break;
    }
  }
