/* ----------------------------------------------------------------------------
 *  $RCSfile: sdp.c,v $
 * 
 * $Revision: 1.3 $
 *   $Author: larse $
 *     $Date: 2000/06/07 16:43:19 $
 *    $State: Exp $
 * ----------------------------------------------------------------------------
 * Copyright 1999-2000, Lars Eggert <larse@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the "Artistic License" which comes with this
 * Kit.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * Artistic License for more details.
 * ----------------------------------------------------------------------------
 *
 * $Log: sdp.c,v $
 * Revision 1.3  2000/06/07 16:43:19  larse
 * Moved software over to sourceforge.net under the Artistic License. No
 * functional changes to latest release.
 *
 * Revision 1.2  1999/05/18 00:47:25  larse
 * Added ARP/RARP and DVMRP. Factored out common code to basics.c. Added
 * IGMP traceroute (untested).
 *
 * Revision 1.1  1999/05/12 13:05:01  larse
 * Added support for SAP and SAP. Removed duplicate includes from other
 * sources. Changed output of IP router alert option in last version, but
 * forgot to document.
 *
 * ----------------------------------------------------------------------------
 */


/* Define a marker for ident(1). */
static const char rcsid[] = 
  "$Id: sdp.c,v 1.3 2000/06/07 16:43:19 larse Exp $";


#include <stdio.h>
#include <string.h>

#include "ipdump.h"
#include "indent.h"
#include "scan.h"


/* local header id */
static const char hdr[] = "SDP";


/* print sdp */
void print_sdp(void)
  {
  /* since we print the payload, it's okay to change data to avoid a copy */
  const u_long l = left();
  char *payload = (char *)next(l);
  char *line;

  if(payload == 0) return;
  /* strsep will need a terminating zero to avoid reading more than left */
  payload[l] = 0;
  /* get each line and print it */
  line = strsep(&payload, "\n\r");
  /* see if we have mime header */
  if(line && strcmp(line, "Content-Type:") == 0 && 
     strcmp(line, "Content-Type: application/sdp") != 0)
    {
    iprintf(hdr, "%s [*unsupported*]\n", line);
    unsupported++;
    return;
    }
  while(line) 
    {
    if(*line && *line != '\n' && *line != '\r') iprintf(hdr, "%s\n", line);
    line = strsep(&payload, "\n\r");
    }
  }
